<?php
namespace Controllers;
// Контроллер для товаров
class Products extends Controller {

	public function __construct() {
		parent::__construct();
		$this->model=new \Models\Products($this->db, $this->f3);
	}

	// Поиск по штрих-коду
	function search_barcodes() {
		$term=$this->f3->get('GET.product_search');
		$count=$this->f3->get('GET.coeff');
		if(!$count)$count=1;
		if(!$term) {
			$this->f3->set('page_data', $this->messages->message('not_enough_data'));
			return;
		}

		$page=$this->f3->get('GET.page');
		if(!$page) $page=1;

		$s=new \Models\Settings($this->f3, $this->db);
		$sets=$s->get_settings(array('weight_code_pr', 'card_code_pr'));
		// Проверяем штрих-код на принадлежность к весовому типу
		if(mb_substr($term, 0, 2)==$sets['weight_code_pr'] && mb_strlen($term)==13) {
			$barcode=$term;
			$term=mb_substr($barcode, 0, 7);
			$count=mb_substr($barcode, 7, 5);
			$count=number_format(round($count/1000, 3), 3, '.', '');
		}
		// Проверяем штрих-код на принадлежность к карте клиента
		if(mb_substr($term, 0, 2)==$sets['card_code_pr'] && mb_strlen($term)==13) {
			$this->f3->reroute('/partners/search?card='.$term);
			return;
		}

		$limit=$this->f3->get('lines_of_page');
		$res=$this->model->search($term, ($page-1)*$limit, $limit, false);
		if(count($res['products'])>1) {
			$this->f3->set('pagination', $this->pagination($res['count'], $page));
			$this->f3->set('products', $res['products']);
			$this->f3->set('page_data', $this->model->page_data('search'));
		}
		elseif(count($res['products'])==1) {
			$res=array(
				'success'=>true,
				'txt'=>$this->messages->message('loading')['txt'],
				'next_step'=>'/receipts/add_line?product_id='.$res['products'][0]['id'].'&count='.$count
			);
			echo json_encode($res);
			exit();
		}
		else {
			$this->f3->set('page_data', $this->messages->message('not_found'));
		}
	}

	// Отображение быстрых товаров
	function fast_products() {
		$page=$this->f3->get('GET.page');
		if(!$page) $page=1;
		$limit=$this->f3->get('lines_of_page');
		$res=$this->model->fast_products(($page-1)*$limit, $limit);
		if(count($res['products'])>0) {
			$this->f3->set('pagination', $this->pagination($res['count'], $page));
			$this->f3->set('products', $res['products']);
			$this->f3->set('page_data', $this->model->page_data('search'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message('not_found'));
		}
	}

	// Показ картинки товара
	function img() {
		$img=$this->f3->get('GET.img');
		if(!$img) {
			$this->f3->set('page_data', $this->messages->message('not_found'));
		}
		else {
			$api_data=$this->controller->get_api_config();
			$subdomen=$api_data['domen'];
			$subdomen=mb_substr($subdomen, mb_strpos($subdomen, '//')+2);
			$subdomen=mb_substr($subdomen, 0, mb_strpos($subdomen, '.'));
			$this->f3->set('img', $api_data['domen'].'/upload/'.$subdomen.'/300_300/'.$img);
			$this->f3->set('page_data', $this->model->page_data('img'));
		}
	}
}
